
           *= $0801
           .BYTE $4C,$14,$08,$00,$97
TURBOASS   = 780
           .TEXT "780"
           .BYTE $2C,$30,$3A,$9E,$32,$30
           .BYTE $37,$33,$00,$00,$00
           LDA #1
           STA TURBOASS
           JMP MAIN


PRINT
           .BLOCK
           PLA
           STA PRINT0+1
           PLA
           STA PRINT0+2
           LDX #1
PRINT0
           LDA !*,X
           BEQ PRINT1
           JSR $FFD2
           INX
           BNE PRINT0
PRINT1
           SEC
           TXA
           ADC PRINT0+1
           STA PRINT2+1
           LDA #0
           ADC PRINT0+2
           STA PRINT2+2
PRINT2
           JMP !*
           .BEND


PRINTHB
           .BLOCK
           PHA
           LSR A
           LSR A
           LSR A
           LSR A
           JSR PRINTHN
           PLA
           AND #$0F
PRINTHN
           ORA #$30
           CMP #$3A
           BCC PRINTHN0
           ADC #6
PRINTHN0
           JSR $FFD2
           RTS
           .BEND


WAITBORDER
           .BLOCK
           LDA $D011
           BMI OK
WAIT
           LDA $D012
           CMP #30
           BCS WAIT
OK
           RTS
           .BEND


WAITKEY
           .BLOCK
           JSR $FDA3
WAIT
           JSR $FFE4
           BEQ WAIT
           CMP #3
           BEQ STOP
           RTS
STOP
           LDA TURBOASS
           BEQ BASIC
           JMP $8000
BASIC
           JMP $A474
           .BEND


REPORT
           .BLOCK
           STA SAVEA+1
           STX SAVEX+1
           STY SAVEY+1
           LDA #13
           JSR $FFD2
           JSR $FFD2
           PLA
           STA PRINT0+1
           PLA
           STA PRINT0+2
           LDX #1
PRINT0
           LDA !*,X
           BEQ PRINT1
           JSR $FFD2
           INX
           BNE PRINT0
PRINT1
           SEC
           TXA
           ADC PRINT0+1
           STA PRINT2+1
           LDA #0
           ADC PRINT0+2
           STA PRINT2+2
           JSR PRINT
           .BYTE 13
           .TEXT "IDX"
           .BYTE 0
SAVEX
           LDA #$11
           JSR PRINTHB
           LDA #32
           JSR $FFD2
SAVEA
           LDA #$11
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "RIGHT "
           .BYTE 0
SAVEY
           LDA #$11
           JSR PRINTHB
           JSR WAITKEY
PRINT2
           JMP !*
           .BEND



;COMBINATIONS TESTED
;BEFORE
;  4/6 0 LATCH LOW
;  4/6 1 LATCH LOW
;  4/6 2 LATCH LOW
;  4/6 7 LATCH LOW
;  E/F 0 STOPPED/RUNNING
;  E/F 3 CONTINUOUS/ONE SHOT
;AFTER
;  4/6 0 LATCH LOW
;  4/6 1 LATCH LOW
;  4/6 2 LATCH LOW
;  E/F 0 STOPPED/RUNNING
;  E/F 3 CONTINUOUS/ONE SHOT
;  E/F 4 NO FORCE LOAD/FORCE LOAD
;CHECK
;  4/6 COUNTER LOW
;  5/7 COUNTER HIGH
;  D/D ICR
;  E/F CONTROL

IEINDEX    .BYTE 0
BEINDEX    .BYTE 0
BETAB      .BYTE $00,$01,$08,$09
IETAB      .BYTE $10,$11,$18,$19
I4         .BYTE 0
IE         .BYTE 0
B4         .BYTE 0
BE         .BYTE 0
A4         .BYTE 0
AD         .BYTE 0
AE         .BYTE 0
R4         .BYTE 0
RD         .BYTE 0
RE         .BYTE 0

MAIN
           JSR PRINT
           .BYTE 13
           .TEXT "CIA1TA"
           .BYTE 0

           .BLOCK
           LDA #30
           STA I4
           LDA #20
           STA B4
           LDA #0
           STA IEINDEX
           STA BEINDEX
LOOP
           SEI
           LDA #$7F
           STA $DC0D
           LDA #$81
           STA $DC0D
           JSR WAITBORDER
           LDA #0
           STA $DC0E
           STA $DC05
           LDX IEINDEX
           LDA IETAB,X
           STA IE
           LDX BEINDEX
           LDY BETAB,X
           STY BE
           LDX I4
           STX $DC04
           LDX #$10
           STX $DC0E
           BIT $DC0D
           STA $DC0E
           LDA B4
           STA $DC04
           STY $DC0E
           LDA $DC04
           LDX $DC0D
           LDY $DC0E
           STA A4
           STX AD
           STY AE
           JSR $FDA3
           CLI

           LDA IEINDEX
           ASL A
           ASL A
           ASL A
           ORA BEINDEX
           ASL A
           TAX
           LDA JUMPTAB+0,X
           STA 172
           LDA JUMPTAB+1,X
           STA 173
           JMP (172)

JUMPTAB    .WORD X000,X001,X008,X009
           .WORD X010,X011,X018,X019
           .WORD X100,X101,X108,X109
           .WORD X110,X111,X118,X119
           .WORD X800,X801,X808,X809
           .WORD X810,X811,X818,X819
           .WORD X900,X901,X908,X909
           .WORD X910,X911,X918,X919


X000
X008
X800
X808
           .BLOCK
           LDA I4
           STA R4
           LDA #$00
           STA RD
           LDA BE
           STA RE
           JMP COMPARE
           .BEND


X001
X801
           .BLOCK
           LDA I4
           SEC
           SBC #2
           LDX I4
           CPX #3
           BCS NOLOAD
           LDA B4
           CPX #0
           BNE NODEC
           CMP #2
           BCC NODEC
           SEC
           SBC #1
NODEC
NOLOAD
           STA R4
           LDA #$00
           LDX I4
           CPX #7
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #6
           BCS NOBIT7
           ORA #$80
NOBIT7
           STA RD
           LDA #$01
           STA RE
           JMP COMPARE
           .BEND


X009
X809
           .BLOCK
           LDA I4
           SEC
           SBC #2
           LDX I4
           CPX #3
           BCS NOLOAD
           LDA B4
NOLOAD
           STA R4
           LDA #$00
           LDX I4
           CPX #7
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #6
           BCS NOBIT7
           ORA #$80
NOBIT7
           STA RD
           LDA #$09
           LDX I4
           CPX #$0B
           BCS NOSTOP
           AND #$08
NOSTOP
           STA RE
           JMP COMPARE
           .BEND


X010
X018
X810
X818
           .BLOCK
           LDA B4
           STA R4
           LDA #$00
           STA RD
           LDA BE
           AND #$09
           STA RE
           JMP COMPARE
           .BEND


X011
X811
           .BLOCK
           LDX B4
           CPX #2
           BCC NODEC
           DEX
NODEC
           STX R4
           LDA #$00
           LDX B4
           CPX #6
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #5
           BCS NOBIT7
           ORA #$80
NOBIT7
           LDX I4
           BNE NOBIT07
           ORA #$81
NOBIT07
           STA RD
           STA RD
           LDA BE
           AND #$09
           STA RE
           JMP COMPARE
           .BEND


X019
X819
           .BLOCK
           LDX B4
           CPX #2
           BCC NODEC
           LDA I4
           BEQ NODEC
           DEX
NODEC
           STX R4
           LDA #$00
           LDX B4
           CPX #6
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #5
           BCS NOBIT7
           ORA #$80
NOBIT7
           LDX I4
           BNE NOBIT07
           ORA #$81
NOBIT07
           STA RD
           STA RD
           LDA #$09
           LDX I4
           BEQ STOP
           LDX B4
           CPX #$0A
           BCS NOSTOP
STOP
           AND #$08
NOSTOP
           STA RE
           JMP COMPARE
           .BEND


X100
X108
           .BLOCK
           LDA I4
           LDX #$00
           SEC
           SBC #$0B
           BCS NOLOAD
           LDA B4
           LDX I4
           CPX #$0A
           BCS NOSUB
           SEC
           SBC SUBTAB,X
           BCS NOSUB
           LDA I4
           ASL A
           ASL A
           ASL A
           ASL A
           ORA B4
           LDX #CORR-SPECIAL-1
SEARCH
           CMP SPECIAL,X
           BEQ FOUND
           DEX
           BPL SEARCH
           LDA B4
           JMP NOSUB
FOUND
           LDA CORR,X
NOSUB
           LDX #$81
NOLOAD
           STA R4
           STX RD
           LDA BE
           STA RE
           JMP COMPARE
SUBTAB     .BYTE 5,5,5,3,1,5,4,3,2,1
SPECIAL    .BYTE $71,$62,$53,$52,$51
           .BYTE $31,$23,$22,$21,$13
           .BYTE $12,$11,$03,$02,$01
           .BYTE $00
CORR       .BYTE $00,$01,$02,$00,$00
           .BYTE $00,$02,$00,$00,$02
           .BYTE $00,$00,$02,$00,$00
           .BYTE $00
           .BEND


X101
           .BLOCK
           LDA I4
           SEC
           SBC #$0D
           BEQ LOAD81
           BCC LOAD81
           CMP #$04
           BCC SET81
           BEQ SET01
           LDX #$00
           JMP SET
SET01
           LDX #$01
           JMP SET
LOAD81
           LDA B4
           LDX I4
           CPX #$0C
           BCS SET81
           SEC
           SBC SUBTAB,X
           BEQ TEST
           BCS SET81
TEST
           LDA I4
           ASL A
           ASL A
           ASL A
           ASL A
           ORA B4
           LDX #CORR-SPECIAL-1
SEARCH
           CMP SPECIAL,X
           BEQ FOUND
           DEX
           BPL SEARCH
           LDA B4
           JMP SET81
FOUND
           LDA CORR,X
SET81
           LDX #$81
SET
           STA R4
           STX RD
           LDA #$01
           STA RE
           JMP COMPARE
SUBTAB     .BYTE 7,7,7,5,3,7,6,5,4,3,2
           .BYTE 1
SPECIAL    .BYTE $82,$73,$64,$63,$55
           .BYTE $54,$52,$33,$25,$24
           .BYTE $22,$15,$14,$12,$05
           .BYTE $04,$02
CORR       .BYTE $01,$02,$03,$01,$04
           .BYTE $02,$01,$02,$04,$02
           .BYTE $01,$04,$02,$01,$04
           .BYTE $02,$01
           .BEND


X109
           .BLOCK
           LDA I4
           SEC
           SBC #$0D
           BEQ LOAD81
           BCC LOAD81
           CMP #$04
           BCC SET81
           BEQ SET01
           LDX #$00
           JMP SET
SET01
           LDX #$01
           JMP SET
LOAD81
           LDA B4
           LDX I4
           CPX #$0C
           BCS SET81
           SEC
           SBC SUBTAB,X
           BEQ RELOAD
           BCS SET81
RELOAD
           LDA B4
SET81
           LDX #$81
SET
           STA R4
           STX RD
           LDY #$08
           LDX I4
           CPX #$16
           BCS START
           CPX #$0A
           BCS SETE
           LDA B4
           CMP B4COMP,X
           BCC SETE
START
           LDY #$09
SETE
           STY RE
           JMP COMPARE
SUBTAB     .BYTE 7,7,7,5,3,7,6,5,4,3,0
           .BYTE 0
B4COMP     .BYTE $10,$10,$10,$0E,$0C
           .BYTE $10,$0F,$0E,$0D,$0C
           .BEND


X110
X118
           .BLOCK
           LDA B4
           STA R4
           LDA #$00
           LDX I4
           CPX #$0B
           BCS NOFIRE
           LDA #$81
NOFIRE
           STA RD
           LDA BE
           AND #$09
           STA RE
           JMP COMPARE
           .BEND


X111
           .BLOCK
           LDX B4
           CPX #2
           BCC NODEC
           DEX
NODEC
           STX R4
           LDA #$00
           LDX B4
           CPX #6
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #5
           BCS NOBIT7
           ORA #$80
NOBIT7
           LDX I4
           BNE NOBIT07
           ORA #$81
NOBIT07
           LDX I4
           CPX #$0C
           BCS NOFIRE
           LDA #$81
NOFIRE
           STA RD
           LDA BE
           AND #$09
           STA RE
           JMP COMPARE
           .BEND


X119
           .BLOCK
           LDX B4
           CPX #2
           BCC NODEC
           LDA I4
           CMP #$0C
           BCS DODEC
           CMP #$0A
           BCS NODEC
           CPX #$0F
           BCS DODEC
           ASL A
           ASL A
           ASL A
           ASL A
           ORA B4
           LDY #$12
SEARCH
           CMP NODECTAB,Y
           BEQ NODEC
           DEY
           BPL SEARCH
DODEC
           DEX
NODEC
           STX R4
           LDA #$00
           LDX B4
           CPX #6
           BCS NOBIT0
           ORA #$01
NOBIT0
           CPX #5
           BCS NOBIT7
           ORA #$80
NOBIT7
           LDX I4
           CPX #$0C
           BCS NOBIT07
           ORA #$81
NOBIT07
           STA RD
           LDA #$09
           LDX I4
           CPX #$0A
           BCC TESTSTOP
           CPX #$0C
           BCC STOP
TESTSTOP
           LDY B4
           CPY #$0A
           BCS NOSTOP
STOP
           LDA #$08
NOSTOP
           STA RE
           JMP COMPARE
NODECTAB   .BYTE $82,$73,$72,$64,$63
           .BYTE $55,$54,$52,$33,$32
           .BYTE $25,$24,$22,$15,$14
           .BYTE $12,$05,$04,$02
           .BEND


X900
X908
           .BLOCK
           LDA I4
           CMP #$05
           BCC SET81
           LDX #$00
           SEC
           SBC #$0B
           BCS NOLOAD
           LDA B4
SET81
           LDX #$81
NOLOAD
           STA R4
           STX RD
           LDA BE
           STA RE
           JMP COMPARE
           .BEND


X901
           .BLOCK
           LDA I4
           CMP #$0E
           BCS SUBD
           CMP #$04
           BEQ SUB2
           CMP #$03
           BEQ SUB2
           TAX
           LDA B4
           SEC
           SBC SUBTAB,X
           BEQ LOAD
           BCS SET4
LOAD
           LDA B4
           JMP SET4
SUBD
           SEC
           SBC #$0D
           JMP SET4
SUB2
           SEC
           SBC #$02
SET4
           STA R4

           LDX #$00
           LDA I4
           CMP #$11
           BNE NOBIT0
           LDX #$01
NOBIT0
           BCS NOBIT7
           LDX #$81
NOBIT7
           STX RD
           LDA #$01
           LDX I4
           CPX #$0A
           BNE NOSTOP
           LDA #$00
NOSTOP
           STA RE
           JMP COMPARE
SUBTAB     .BYTE 1,0,0,0,0,2,2,2,2,2
           .BYTE 0,1,0,0
           .BEND


X909
           .BLOCK
           LDA I4
           CMP #4
           BEQ SUB2
           CMP #3
           BEQ SUB2
           SEC
           SBC #$0D
           BEQ LOAD
           BCS NOLOAD
LOAD
           LDX I4
           LDA B4
           SEC
           SBC SUBTAB,X
           BEQ RELOAD
           BCS NOLOAD
RELOAD
           LDA B4
           JMP NOLOAD
SUB2
           SEC
           SBC #2
NOLOAD
           STA R4
           LDA #$00
           LDX I4
           CPX #$11
           BNE NOBIT0
           LDA #$01
NOBIT0
           BCS NOBIT7
           LDA #$81
NOBIT7
           STA RD
           LDA #$08
           LDX I4
           CPX #$16
           BCS START
           CPX #$0A
           BCS SETE
           CPX #$05
           BCC SETE
           LDX B4
           CPX #$0B
           BCC SETE
START
           LDA #$09
SETE
           STA RE
           JMP COMPARE
SUBTAB     .BYTE 0,0,0,0,0,2,2,2,2,2
           .BYTE 0,0,0,0
           .BEND


X910
X918
           .BLOCK
           LDA B4
           STA R4
           LDA #$00
           LDX I4
           CPX #$0B
           BCS SETD
           LDA #$81
SETD
           STA RD
           LDA BE
           AND #$09
           STA RE
           JMP COMPARE
           .BEND


X911
           .BLOCK
           LDA B4
           LDX I4
           CPX #$0A
           BEQ NOLOAD
           SEC
           SBC #$01
           BEQ LOAD
           BCS NOLOAD
LOAD
           LDA B4
NOLOAD
           STA R4
           LDA I4
           CMP #$0C
           BCC SET81
           LDA #$00
           LDX B4
           CPX #$05
           BNE NOBIT0
           LDA #$01
NOBIT0
           BCS NOBIT7
SET81
           LDA #$81
NOBIT7
           STA RD
           LDA BE
           AND #$09
           LDX I4
           CPX #$0A
           BNE NOSTOP
           LDA #$00
NOSTOP
           STA RE
           JMP COMPARE
           .BEND


X919
           .BLOCK
           LDX I4
           BEQ LOAD
           CPX #$0B
           BEQ LOAD
           CPX #$0A
           BEQ LOAD
           LDA B4
           SEC
           SBC #$01
           BEQ LOAD
           BCS NOLOAD
LOAD
           LDA B4
NOLOAD
           STA R4
           LDX I4
           CPX #$0C
           BCC SET81
           LDA #$00
           LDX B4
           CPX #$05
           BNE NOBIT0
           LDA #$01
NOBIT0
           BCS NOBIT7
SET81
           LDA #$81
NOBIT7
           STA RD
           LDA #$09
           LDX I4
           BEQ STOP
           CPX #$0A
           BCC TESTB
           CPX #$0C
           BCC STOP
TESTB
           LDX B4
           CPX #$0A
           BCS NOSTOP
STOP
           LDA #$08
NOSTOP
           STA RE
           JMP COMPARE
           .BEND


COMPARE
           LDA A4
           CMP R4
           BNE ERROR
           LDA AD
           CMP RD
           BNE ERROR
           LDA AE
           CMP RE
           BNE ERROR
NOERROR
           INC BEINDEX
           LDA BEINDEX
           CMP #8
           BCC JMPLOOP
           LDA #0
           STA BEINDEX
           INC IEINDEX
           LDA IEINDEX
           CMP #4
           BCC JMPLOOP
           LDA #0
           STA IEINDEX
           DEC B4
           BPL JMPLOOP
           LDA #20
           STA B4
           DEC I4
           BPL JMPLOOP
           JMP FINISH
JMPLOOP
           JMP LOOP
ERROR
           JSR PRINT
           .BYTE 13,13
           .TEXT "INIT  "
           .BYTE 0
           LDA I4
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA B4
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA IE
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA BE
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "AFTER "
           .BYTE 0
           LDA A4
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA AD
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA AE
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "RIGHT "
           .BYTE 0
           LDA R4
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA RD
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA RE
           JSR PRINTHB
           JSR WAITKEY
           JMP NOERROR
FINISH
           .BEND


           JSR PRINT
           .TEXT " - OK"
           .BYTE 13,0
           LDA TURBOASS
           BEQ LOAD
           JSR WAITKEY
           JMP $8000
LOAD
           JSR PRINT
NAME       .TEXT "CIA1TB"
NAMELEN    = *-NAME
           .BYTE 0
           LDA #0
           STA $0A
           STA $B9
           LDA #NAMELEN
           STA $B7
           LDA #<NAME
           STA $BB
           LDA #>NAME
           STA $BC
           PLA
           PLA
           JMP $E16F

