
           *= $0801
           .BYTE $4C,$14,$08,$00,$97
TURBOASS   = 780
           .TEXT "780"
           .BYTE $2C,$30,$3A,$9E,$32,$30
           .BYTE $37,$33,$00,$00,$00
           LDA #1
           STA TURBOASS
           JMP MAIN


PRINT
           .BLOCK
           PLA
           STA PRINT0+1
           PLA
           STA PRINT0+2
           LDX #1
PRINT0
           LDA !*,X
           BEQ PRINT1
           JSR $FFD2
           INX
           BNE PRINT0
PRINT1
           SEC
           TXA
           ADC PRINT0+1
           STA PRINT2+1
           LDA #0
           ADC PRINT0+2
           STA PRINT2+2
PRINT2
           JMP !*
           .BEND


PRINTHB
           .BLOCK
           PHA
           LSR A
           LSR A
           LSR A
           LSR A
           JSR PRINTHN
           PLA
           AND #$0F
PRINTHN
           ORA #$30
           CMP #$3A
           BCC PRINTHN0
           ADC #6
PRINTHN0
           JSR $FFD2
           RTS
           .BEND



DELAY
           .BLOCK
           STA $DD04
           STX $DD05
           LDA #%00011001
           STA $DD0E
           LDA #1
WAIT
           BIT $DD0E
           BNE WAIT
           RTS
           .BEND


GATIMER    *= *+4
GATIMERC   *= *+4


INITTIMER
           .BLOCK
           LDA #0
           LDX #3
CLEAR
           STA GATIMERC,X
           DEX
           BPL CLEAR
           JSR STARTTIMER
           JSR STOPTIMER
           LDX #3
SETC
           LDA GATIMER,X
           STA GATIMERC,X
           DEX
           BPL SETC
           RTS
           .BEND


STARTTIMER
           .BLOCK
           SEI
           LDA $D011
           AND #%11101111
          ; STA $D011
           BMI ISBORDER
WAITBORDER
           LDA $D012
           CMP #30
           BCS WAITBORDER
ISBORDER
           LDA #%01111111
           STA $DD0D
           LDA #0
           STA $DD0E
           STA $DD0F
           LDA #$FF
           STA $DD04
           STA $DD05
           STA $DD06
           STA $DD07
           LDA #%01010001
           STA $DD0F
           LDA #%00010001
           STA $DD0E
           RTS
           .BEND


STOPTIMER
           .BLOCK
           LDX #0
           STX $DD0E
           CLD
           SEC
           LDA $DD04
           EOR #$FF
           SBC GATIMERC+0
           STA GATIMER+0
           LDA $DD05
           EOR #$FF
           SBC GATIMERC+1
           STA GATIMER+1
           LDA $DD06
           EOR #$FF
           SBC GATIMERC+2
           STA GATIMER+2
           LDA $DD07
           EOR #$FF
           SBC GATIMERC+3
           STA GATIMER+3
           CLI
           LDA $D011
           ORA #%00010000
           STA $D011
           RTS
           .BEND


PRINTTIMER
           .BLOCK
           LDA GATIMER+2
           STA $63
           LDA GATIMER+3
           STA $62
           LDX #$90
           SEC
           JSR $BC49
           LDA #<R65536
           LDY #>R65536
           JSR $BA28
           JSR $BC0C
           LDA GATIMER+0
           STA $63
           LDA GATIMER+1
           STA $62
           LDX #$90
           SEC
           JSR $BC49
           JSR $B86A
           JSR $BDDD
           LDX $0100
           CPX #32
           BNE NEGATIVE
           CLC
           ADC #1
NEGATIVE
           JMP $AB1E
R65536     .BYTE $91,$00,$00,$00,$00
           .BEND

GSAVESP    .BYTE 0
GASTACK    *= *+256

SAVESTACK
           .BLOCK
           TSX
           STX GSAVESP
           LDX #0
SAVE
           LDA $0100,X
           STA GASTACK,X
           INX
           BNE SAVE
           RTS
           .BEND


RESTORESTACK
           .BLOCK
           PLA
           STA RETURN+1
           PLA
           STA RETURN+2
           LDX GSAVESP
           INX
           INX
           TXS
           LDX #0
RESTORE
           LDA GASTACK,X
           STA $0100,X
           INX
           BNE RESTORE
RETURN
           JMP $1111
           .BEND

ADDRESSING
           .WORD BRKN
           .WORD RIX
           .WORD HLTN
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD PHPN
           .WORD B
           .WORD N
           .WORD B
           .WORD RA
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX
           .WORD JSRW
           .WORD RIX
           .WORD HLTN
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD PLPN
           .WORD B
           .WORD N
           .WORD B
           .WORD RA
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX
           .WORD RTIN
           .WORD RIX
           .WORD HLTN
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD PHAN
           .WORD B
           .WORD N
           .WORD B
           .WORD JMPW
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX
           .WORD RTSN
           .WORD RIX
           .WORD HLTN
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD PLAN
           .WORD B
           .WORD N
           .WORD B
           .WORD JMPI
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX
           .WORD B
           .WORD WIX
           .WORD B
           .WORD RIX
           .WORD WZ
           .WORD WZ
           .WORD WZ
           .WORD RZ
           .WORD N
           .WORD B
           .WORD N
           .WORD B
           .WORD WA
           .WORD WA
           .WORD WA
           .WORD RA
           .WORD R
           .WORD WIY
           .WORD HLTN
           .WORD WIY
           .WORD WZX
           .WORD WZX
           .WORD WZY
           .WORD RZY
           .WORD N
           .WORD WAY
           .WORD N
           .WORD WAY
           .WORD WAX
           .WORD WAX
           .WORD WAY
           .WORD WAY
           .WORD B
           .WORD RIX
           .WORD B
           .WORD RIX
           .WORD RZ
           .WORD RZ
           .WORD RZ
           .WORD RZ
           .WORD N
           .WORD B
           .WORD N
           .WORD B
           .WORD RA
           .WORD RA
           .WORD RA
           .WORD RA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD RIY
           .WORD RZX
           .WORD RZX
           .WORD RZY
           .WORD RZY
           .WORD N
           .WORD RAY
           .WORD N
           .WORD RAY
           .WORD RAX
           .WORD RAX
           .WORD RAY
           .WORD RAY
           .WORD B
           .WORD RIX
           .WORD B
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD N
           .WORD B
           .WORD N
           .WORD B
           .WORD RA
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX
           .WORD B
           .WORD RIX
           .WORD B
           .WORD MIX
           .WORD RZ
           .WORD RZ
           .WORD MZ
           .WORD MZ
           .WORD N
           .WORD B
           .WORD N
           .WORD B
           .WORD RA
           .WORD RA
           .WORD MA
           .WORD MA
           .WORD R
           .WORD RIY
           .WORD HLTN
           .WORD MIY
           .WORD RZX
           .WORD RZX
           .WORD MZX
           .WORD MZX
           .WORD N
           .WORD RAY
           .WORD N
           .WORD MAY
           .WORD RAX
           .WORD RAX
           .WORD MAX
           .WORD MAX

CMD        .BYTE 0

MAIN
           JSR PRINT
           .BYTE 13
           .TEXT "CPUTIMING"
           .BYTE 0

           TSX
           STX ERROR+1
           LDA #0
           STA CMD
           JSR INITTIMER

LOOP
           LDA #<ADDRESSING
           LDX #>ADDRESSING
           CLC
           ADC CMD
           BCC NOINC1
           INX
NOINC1
           CLC
           ADC CMD
           BCC NOINC2
           INX
NOINC2
           STA 172
           STX 173
           LDY #0
           LDA (172),Y
           STA JUMP+1
           INY
           LDA (172),Y
           STA JUMP+2
           LDA #0
           STA GATIMER+0
           STA GATIMER+1
           STA GATIMER+2
           STA GATIMER+3
JUMP
           JSR $1111
NOERROR
           INC CMD
           BNE LOOP

           JMP OK

COMPARE
           CMP GATIMER+0
           BNE ERROR
           LDX GATIMER+1
           BNE ERROR
           LDX GATIMER+2
           BNE ERROR
           LDX GATIMER+3
           BNE ERROR
           RTS

ERROR
           LDX #$11
           TXS
           PHA
           LDA #13
           JSR $FFD2
           LDA CMD
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "CLOCKS "
           .BYTE 0
           JSR PRINTTIMER
           JSR PRINT
           .BYTE 13
           .TEXT "RIGHT  "
           .BYTE 0
           PLA
           STA GATIMER+0
           LDA #0
           STA GATIMER+1
           STA GATIMER+2
           STA GATIMER+3
           JSR PRINTTIMER
WAITK
           JSR $FFE4
           BEQ WAITK
           CMP #3
           BEQ STOP
           JMP NOERROR
STOP
           LDA TURBOASS
           BEQ BASIC
           JMP $8000
BASIC
           JMP $A474


OK
           JSR PRINT
           .TEXT " - OK"
           .BYTE 13,0
           LDA TURBOASS
           BEQ LOAD
WAITKEY    JSR $FFE4
           BEQ WAITKEY
           JMP $8000

LOAD
           LDA #47
           STA 0
           JSR PRINT
NAME       .TEXT "IRQ"
NAMELEN    = *-NAME
           .BYTE 0
           LDA #0
           STA $0A
           STA $B9
           LDA #NAMELEN
           STA $B7
           LDA #<NAME
           STA $BB
           LDA #>NAME
           STA $BC
           PLA
           PLA
           JMP $E16F


N
           JSR SAVESTACK
           LDA CMD
           STA NX
           LDA #$7F
           STA $DC0D
           JSR STARTTIMER
NX
           NOP
           JSR STOPTIMER
           LDA #$81
           STA $DC0D
           JSR RESTORESTACK
           LDA #2
           JMP COMPARE


B
           LDA CMD
           STA BX
           JSR STARTTIMER
BX
           LDA #0
           JSR STOPTIMER
           LDA #2
           JMP COMPARE

RZ
WZ
           .BLOCK
           LDA CMD
           STA COMMAND
           JSR STARTTIMER
COMMAND
           LDA 2
           JSR STOPTIMER
           LDA #3
           JMP COMPARE
           .BEND


MZ
           .BLOCK
           LDA CMD
           STA COMMAND
           JSR STARTTIMER
COMMAND
           LDA 2
           JSR STOPTIMER
           LDA #5
           JMP COMPARE
           .BEND


RZX
RZY
WZX
WZY
           .BLOCK
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #2
           LDY #2
NOWRAP
           LDA 0,X
           JSR STOPTIMER
           LDA #8
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #$FF
           LDY #$FF
WRAP
           LDA 3,X
           JSR STOPTIMER
           LDA #8
           JMP COMPARE
           .BEND



MZX
MZY
           .BLOCK
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #2
           LDY #2
NOWRAP
           LDA 0
           JSR STOPTIMER
           LDA #10
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #$FF
           LDY #$FF
WRAP
           LDA 3
           JSR STOPTIMER
           LDA #10
           JMP COMPARE
           .BEND


RA
WA
           .BLOCK
           LDA CMD
           STA COMMAND
           JSR STARTTIMER
COMMAND
           LDA $FFFF
           JSR STOPTIMER
           LDA #4
           JMP COMPARE
           .BEND


MA
           .BLOCK
           LDA CMD
           STA COMMAND
           JSR STARTTIMER
COMMAND
           LDA $FFFF
           JSR STOPTIMER
           LDA #6
           JMP COMPARE
           .BEND


RAX
RAY
           .BLOCK
           JSR SAVESTACK
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #0
           LDY #0
NOWRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #8
           JSR COMPARE
           JSR SAVESTACK
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #3
           LDY #3
WRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #9
           JMP COMPARE
           .BEND


WAX
WAY
           .BLOCK
           JSR SAVESTACK
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #0
           LDY #0
NOWRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #9
           JSR COMPARE
           JSR SAVESTACK
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #3
           LDY #3
WRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #9
           JMP COMPARE
           .BEND


MAX
MAY
           .BLOCK
           JSR SAVESTACK
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #0
           LDY #0
NOWRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #11
           JSR COMPARE
           JSR SAVESTACK
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #3
           LDY #3
WRAP
           LDA $FFFF
           JSR STOPTIMER
           JSR RESTORESTACK
           LDA #11
           JMP COMPARE
           .BEND


RIX
WIX
           .BLOCK
           LDA #$FF
           STA 172
           STA 173
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #0
NOWRAP
           LDA (172,X)
           JSR STOPTIMER
           LDA #8
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #$FF
WRAP
           LDA (173,X)
           JSR STOPTIMER
           LDA #8
           JMP COMPARE
           .BEND


MIX
           .BLOCK
           LDA #$FF
           STA 172
           STA 173
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDX #0
NOWRAP
           LDA (172,X)
           JSR STOPTIMER
           LDA #10
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDX #$FF
WRAP
           LDA (173,X)
           JSR STOPTIMER
           LDA #10
           JMP COMPARE
           .BEND


RIY
           .BLOCK
           LDA #$FF
           STA 172
           STA 173
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDY #0
NOWRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #7
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDY #3
WRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #8
           JMP COMPARE
           .BEND


WIY
           .BLOCK
           LDA #$FF
           STA 172
           STA 173
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDY #0
NOWRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #8
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDY #3
WRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #8
           JMP COMPARE
           .BEND


MIY
           .BLOCK
           LDA #$FF
           STA 172
           STA 173
           LDA CMD
           STA NOWRAP
           JSR STARTTIMER
           LDY #0
NOWRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #10
           JSR COMPARE
           LDA CMD
           STA WRAP
           JSR STARTTIMER
           LDY #3
WRAP
           LDA (172),Y
           JSR STOPTIMER
           LDA #10
           JMP COMPARE
           .BEND


R
           .BLOCK
FROM       = $2000
TO         = $2000
           LDX #$F7
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$34
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #18
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $2000
TO         = $2000
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #19
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $2000
TO         = $207F
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #19
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $1FFF
TO         = $2000
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #20
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $1FFF
TO         = $207E
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #20
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $1FFF
TO         = $1FFC
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #19
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $1FFF
TO         = $1F7F
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #19
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $2000
TO         = $1FFD
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #20
           JSR COMPARE
           .BEND

           .BLOCK
FROM       = $2000
TO         = $1F80
           LDX #$34
           LDA CMD
           STA FROM-2
           AND #$20
           BEQ CLEAR
           LDX #$F7
CLEAR
           TXA
           PHA
           LDA #TO-FROM&$FF
           STA FROM-1
           LDA #$60
           STA TO
           JSR STARTTIMER
           PLP
           JSR FROM-2
           JSR STOPTIMER
           LDA #20
           JSR COMPARE
           .BEND

           RTS


BRKN
           LDA #$7F
           STA $DC0D
           LDA #$35
           STA 1
           LDA #<BREAK
           STA $FFFE
           LDA #>BREAK
           STA $FFFF
           JSR STARTTIMER
           BRK
BREAK
           JSR STOPTIMER
           PLA
           PLA
           PLA
           LDA #$37
           STA 1
           LDA #$81
           STA $DC0D
           LDA #7
           JMP COMPARE


PHAN
PHPN
           .BLOCK
           LDA CMD
           STA COMMAND
           JSR STARTTIMER
COMMAND
           PHA
           JSR STOPTIMER
           PLA
           LDA #3
           JMP COMPARE
           .BEND


PLAN
PLPN
           .BLOCK
           LDA CMD
           STA COMMAND
           LDA #$F7
           PHA
           JSR STARTTIMER
COMMAND
           PLA
           JSR STOPTIMER
           LDA #4
           JMP COMPARE
           .BEND


JMPW
           .BLOCK
           JSR STARTTIMER
           JMP CONTINUE
CONTINUE
           JSR STOPTIMER
           LDA #3
           JMP COMPARE
           .BEND


JMPI
           .BLOCK
           LDA #<NOWRAP
           STA $2000
           LDA #>NOWRAP
           STA $2001
           JSR STARTTIMER
           JMP ($2000)
NOWRAP
           JSR STOPTIMER
           LDA #5
           JSR COMPARE
           LDA #<WRAP
           STA $1FFF
           LDA #>WRAP
           STA $1F00
           JSR STARTTIMER
           JMP ($1FFF)
WRAP
           JSR STOPTIMER
           LDA #5
           JMP COMPARE
           .BEND


JSRW
           .BLOCK
           JSR STARTTIMER
           JSR CONTINUE
CONTINUE
           JSR STOPTIMER
           PLA
           PLA
           LDA #6
           JMP COMPARE
           .BEND


RTSN
           .BLOCK
           LDA #>CONTINUE-1
           PHA
           LDA #<CONTINUE-1
           PHA
           JSR STARTTIMER
           RTS
CONTINUE
           JSR STOPTIMER
           LDA #6
           JMP COMPARE
           .BEND


RTIN
           .BLOCK
           LDA #>CONTINUE
           PHA
           LDA #<CONTINUE
           PHA
           SEI
           PHP
           JSR STARTTIMER
           RTI
CONTINUE
           JSR STOPTIMER
           LDA #6
           JMP COMPARE
           .BEND


HLTN
           RTS

