
           *= $0801
           .BYTE $4C,$14,$08,$00,$97
TURBOASS   = 780
           .TEXT "780"
           .BYTE $2C,$30,$3A,$9E,$32,$30
           .BYTE $37,$33,$00,$00,$00
           LDA #1
           STA TURBOASS
           JMP MAIN

CODE       = $FFFE
DATA       = $03C0
ZERODATA   = $F7
ZEROPTR    = $F7;$F8

PTABLE     = 172;173
BCMD       .BYTE 0
PCODE      = 174;175

DB         = %00011011
AB         = %11000110
XB         = %10110001
YB         = %01101100

DA         = DATA
AA         .BYTE 0
XA         .BYTE 0
YA         .BYTE 0
PA         .BYTE 0

RAM
           LDA #127
           STA $DC0D
           LDA #$03
           STA 0
           LDA #$14
           STA 1
           RTS

ROM
           LDA #$2F
           STA 0
           LDA #$37
           STA 1
           LDA #129
           STA $DC0D
           RTS


MAIN
           JSR PRINT
           .BYTE 13
           .TEXT "TRAP16"
           .BYTE 0
           LDA #<CODE
           STA PCODE+0
           LDA #>CODE
           STA PCODE+1

           LDA #<TABLE
           STA PTABLE+0
           LDA #>TABLE
           STA PTABLE+1

NEXTCOMMAND

WAITBORDER
           LDA $D011
           BMI ISBORDER
           LDA $D012
           CMP #30
           BCS WAITBORDER
ISBORDER
           JSR RAM
           LDA #$60
           STA $FFFF
           STA 2
           STA 3
           LDY #0
           LDA BCMD
           STA (PCODE),Y

           LDY #3
           LDA (PTABLE),Y
           STA JUMP+1
           INY
           LDA (PTABLE),Y
           STA JUMP+2

JUMP       JSR $1111

           JSR ROM

           LDY #5
           LDA DA
           CMP (PTABLE),Y
           BNE ERROR
           INY
           LDA AA
           CMP (PTABLE),Y
           BNE ERROR
           INY
           LDA XA
           CMP (PTABLE),Y
           BNE ERROR
           INY
           LDA YA
           CMP (PTABLE),Y
           BNE ERROR
           INY
           LDA PA
           CMP (PTABLE),Y
           BNE ERROR
NOSTOP
           JSR ROM
           CLC
           LDA PTABLE+0
           ADC #10
           STA PTABLE+0
           LDA PTABLE+1
           ADC #0
           STA PTABLE+1
           INC BCMD
           BNE JMPNEXTCOMMAND
           JMP OK
JMPNEXTCOMMAND
           JMP NEXTCOMMAND

ERROR
           JSR ROM
           LDA #13
           JSR $FFD2
           LDY #0
           LDA (PTABLE),Y
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR $FFD2
           LDA #32
           JSR $FFD2
           LDA BCMD
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "AFTER  "
           .BYTE 0
           LDA DA
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           JSR $FFD2
           LDA AA
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA XA
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           LDA YA
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           JSR $FFD2
           LDA PA
           JSR PRINTHB
           JSR PRINT
           .BYTE 13
           .TEXT "RIGHT  "
           .BYTE 0
           LDY #5
           LDA (PTABLE),Y
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR PRINTHB
           LDA #32
           JSR $FFD2
           JSR $FFD2
           INY
           LDA (PTABLE),Y
           JSR PRINTHB
           LDA #13
           JSR $FFD2
WAITKEY
           JSR $FFE4
           BEQ WAITKEY
           CMP #3
           BNE JMPNOSTOP
           LDA TURBOASS
           BEQ RETURN
           JMP $8000
JMPNOSTOP
           JMP NOSTOP
RETURN
           LDA #47
           STA 0
           RTS

OK
           JSR PRINT
           .TEXT " - OK"
           .BYTE 13,0
           LDA TURBOASS
           BEQ LOAD
WAIT       JSR $FFE4
           BEQ WAIT
           JMP $8000

LOAD
           LDA #47
           STA 0
           JSR PRINT
NAME       .TEXT "TRAP17"
NAMELEN    = *-NAME
           .BYTE 0
           LDA #0
           STA $0A
           STA $B9
           LDA #NAMELEN
           STA $B7
           LDA #<NAME
           STA $BB
           LDA #>NAME
           STA $BC
           PLA
           PLA
           JMP $E16F

PRINT      PLA
           .BLOCK
           STA PRINT0+1
           PLA
           STA PRINT0+2
           LDX #1
PRINT0     LDA !*,X
           BEQ PRINT1
           JSR $FFD2
           INX
           BNE PRINT0
PRINT1     SEC
           TXA
           ADC PRINT0+1
           STA PRINT2+1
           LDA #0
           ADC PRINT0+2
           STA PRINT2+2
PRINT2     JMP !*
           .BEND

PRINTHB
           .BLOCK
           PHA
           LSR A
           LSR A
           LSR A
           LSR A
           JSR PRINTHN
           PLA
           AND #$0F
PRINTHN
           ORA #$30
           CMP #$3A
           BCC PRINTHN0
           ADC #6
PRINTHN0
           JSR $FFD2
           RTS
           .BEND


SAVESP     .BYTE 0
SAVEDSTACK = $2A00;2AFF


SAVESTACK
           .BLOCK
           TSX
           STX SAVESP
           LDX #0
SAVE
           LDA $0100,X
           STA SAVEDSTACK,X
           INX
           BNE SAVE
           RTS
           .BEND


RESTORESTACK
           .BLOCK
           PLA
           STA RETLOW+1
           PLA
           STA RETHIGH+1
           LDX SAVESP
           INX
           INX
           TXS
           LDX #0
RESTORE
           LDA SAVEDSTACK,X
           STA $0100,X
           INX
           BNE RESTORE
RETHIGH
           LDA #$11
           PHA
RETLOW
           LDA #$11
           PHA
           RTS
           .BEND

EXECUTE
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JSR JMPPCODE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS

JMPPCODE
           JMP (PCODE)

N
           JSR EXECUTE
           RTS

B
           LDA #DB
           STA $FFFF
           LDA #$87
           STA 0
           JSR EXECUTE
           RTS

Z
           LDA #$87
           STA 0
           LDA #ZERODATA
           LDY #1
           STA (PCODE),Y
           LDA #DB
           STA ZERODATA
           JSR EXECUTE
           LDA ZERODATA
           STA DA
           RTS

ZX
           LDA #$87;SAXZ
           STA 0
           LDA #ZERODATA-XB&$FF
           LDY #1
           STA (PCODE),Y
           LDA #DB
           STA ZERODATA
           JSR EXECUTE
           LDA ZERODATA
           STA DA
           RTS

ZY
           LDA #$87;SAXZ
           STA 0
           LDA #ZERODATA-YB&$FF
           LDY #1
           STA (PCODE),Y
           LDA #DB
           STA ZERODATA
           JSR EXECUTE
           LDA ZERODATA
           STA DA
           RTS

A
           LDY #1
           LDA #<DA
           STA (PCODE),Y
           INY
           LDA #>DA
           STA (PCODE),Y
           JSR EXECUTE
           RTS

AX
           LDY #1
           LDA #<(DA-XB)
           STA (PCODE),Y
           INY
           LDA #>(DA-XB)
           STA (PCODE),Y
           JSR EXECUTE
           RTS

AY
           LDY #1
           LDA #<(DA-YB)
           STA (PCODE),Y
           INY
           LDA #>(DA-YB)
           STA (PCODE),Y
           JSR EXECUTE
           RTS

IX
           LDA #$87;SAXZ
           STA 0
           LDY #1
           LDA #ZEROPTR-XB&$FF
           STA (PCODE),Y
           LDA #<DA
           STA ZEROPTR+0&$FF
           LDA #>DA
           STA ZEROPTR+1&$FF
           JSR EXECUTE
           RTS

IY
           LDA #$87;SAXZ
           STA 0
           LDY #1
           LDA #ZEROPTR
           STA (PCODE),Y
           LDA #<(DA-YB)
           STA ZEROPTR+0&$FF
           LDA #>(DA-YB)
           STA ZEROPTR+1&$FF
           JSR EXECUTE
           RTS

R
           LDA #$87
           STA 0
           LDA #2
           LDY #1
           STA (PCODE),Y
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JSR JMPPCODE
           LDA #$F3
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JSR JMPPCODE
           DEC PCODE+1
           LDA #$60
           LDY #130
           STA (PCODE),Y
           INC PCODE+1
           LDA #128
           LDY #1
           STA (PCODE),Y
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JSR JMPPCODE
           LDA #$F3
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JSR JMPPCODE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS

HLTN
           LDA #0
           STA DA
           STA AA
           STA XA
           STA YA
           STA PA
           RTS


BRKN
           .BLOCK
           LDA #$4C
           STA $3000
           LDA #<CONTINUE
           STA $3001
           LDA #>CONTINUE
           STA $3002
           LDA #$00
           STA $FFFE
           LDA #$30
           STA $FFFF
           LDA #0
           PHA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           LDA #DB
           STA DA
           CLI
           PLA
           PLA
           PLA
           RTS
           .BEND


JMPI
           .BLOCK
           LDA #$00
           STA $FFFF
           LDA #$33
           STA 0
           LDA #<CONTINUE
           STA $3300
           LDA #>CONTINUE
           STA $3301
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS
           .BEND

JMPW
           .BLOCK
           LDA #$00
           STA $FFFF
           LDA #$33
           STA 0
           LDA #$4C
           STA $3300
           LDA #<CONTINUE
           STA $3301
           LDA #>CONTINUE
           STA $3302
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS
           .BEND

JSRW
           .BLOCK
           LDA #$00
           STA $FFFF
           LDA #$33
           STA 0
           LDA #$4C
           STA $3300
           LDA #<CONTINUE
           STA $3301
           LDA #>CONTINUE
           STA $3302
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           PLA
           PLA
           RTS
           .BEND


RTIN
           .BLOCK
           LDA #>CONTINUE
           PHA
           LDA #<CONTINUE
           PHA
           LDA #$B3
           PHA
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS
           .BEND



SHAAY
           .IFPL DA&$FF-$C0
           LDA #>DA
           CLC
           ADC #1
           AND #AB
           AND #XB
           LDY #5
           STA (PTABLE),Y
           JMP AY
           .ENDIF
SHAIY
           .IFPL DA&$FF-$C0
           LDA #>DA
           CLC
           ADC #1
           AND #AB
           AND #XB
           LDY #5
           STA (PTABLE),Y
           JMP IY
           .ENDIF
SHXAY
           .IFPL DA&$FF-$C0
           LDA #>DA
           CLC
           ADC #1
           AND #XB
           LDY #5
           STA (PTABLE),Y
           JMP AY
           .ENDIF
SHYAX
           .IFPL DA&$FF-$C0
           LDA #>DA
           CLC
           ADC #1
           AND #YB
           LDY #5
           STA (PTABLE),Y
           JMP AX
           .ENDIF
SHSAY
           .IFPL DA&$FF-$C0
           .BLOCK
           LDA #AB
           AND #XB
           STA SR+1
           LDX #>DA
           INX
           STX ANDX+1
ANDX
           AND #$11
           LDY #5
           STA (PTABLE),Y
           JSR SAVESTACK
           LDA #<DA-YB
           LDY #1
           STA (PCODE),Y
           LDA #>DA-YB
           INY
           STA (PCODE),Y
           LDA #$4C
           STA 3
           LDA #<CONTINUE
           STA 4
           LDA #>CONTINUE
           STA 5
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           TSX
           STX SA+1
           JSR RESTORESTACK
SA
           LDA #$11
           LDY #6
SR
           CMP #$11
           BNE WRONG
           RTS
WRONG
           PLA
           PLA
           JMP ERROR
           .BEND
           .ENDIF

           .IFMI DA&$FF-$C0
           PLA
           PLA
           JMP NOSTOP
           .ENDIF


TXSN
           .BLOCK
           LDA #$0C
           STA $FFFF
           LDA #$4C
           STA 2
           LDA #<CONTINUE
           STA 3
           LDA #>CONTINUE
           STA 4
           JSR SAVESTACK
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           TSX
           STX NEWSP+1
           JSR RESTORESTACK
NEWSP
           LDA #$11
           CMP #XB
           BNE WRONG
           RTS
WRONG
           PLA
           PLA
           JMP ERROR
           .BEND

PLAN
           .BLOCK
           LDA #$0C
           STA $FFFF
           LDA #$4C
           STA 2
           LDA #<CONTINUE
           STA 3
           LDA #>CONTINUE
           STA 4
           LDA #$F0
           PHA
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS
           .BEND

PHAN
           .BLOCK
           LDA #$0C
           STA $FFFF
           LDA #$4C
           STA 2
           LDA #<CONTINUE
           STA 3
           LDA #>CONTINUE
           STA 4
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           PLA
           CMP #AB
           BNE WRONG
           RTS
WRONG
           PLA
           PLA
           JMP ERROR
           .BEND

PLPN
           .BLOCK
           LDA #$0C
           STA $FFFF
           LDA #$4C
           STA 2
           LDA #<CONTINUE
           STA 3
           LDA #>CONTINUE
           STA 4
           LDA #$B3
           PHA
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           RTS
           .BEND

PHPN
           .BLOCK
           LDA #$0C
           STA $FFFF
           LDA #$4C
           STA 2
           LDA #<CONTINUE
           STA 3
           LDA #>CONTINUE
           STA 4
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           PLA
           CMP #$30
           BNE WRONG
           RTS
WRONG
           PLA
           PLA
           JMP ERROR
           .BEND


LASAY
           .BLOCK
           TSX
           TXA
           AND #DB
           PHP
           LDY #6
           STA (PTABLE),Y
           INY
           STA (PTABLE),Y
           PLA
           AND #%10110010
           LDY #9
           STA (PTABLE),Y
           JSR SAVESTACK
           LDA #<DA-YB
           LDY #1
           STA (PCODE),Y
           LDA #>DA-YB
           INY
           STA (PCODE),Y
           LDA #$4C
           STA 3
           LDA #<CONTINUE
           STA 4
           LDA #>CONTINUE
           STA 5
           LDA #0
           PHA
           LDA #DB
           STA DA
           LDA #AB
           LDX #XB
           LDY #YB
           PLP
           JMP (PCODE)
CONTINUE
           PHP
           CLD
           STA AA
           STX XA
           STY YA
           PLA
           STA PA
           TSX
           STX SA+1
           JSR RESTORESTACK
SA
           LDA #$11
           LDY #6
           CMP (PTABLE),Y
           BNE WRONG
           RTS
WRONG
           PLA
           PLA
           JMP ERROR
           .BEND

TSXN
           JSR EXECUTE
           TSX
           DEX
           DEX
           DEX
           DEX
           PHP
           TXA
           LDY #7
           STA (PTABLE),Y
           PLA
           LDY #9
           STA (PTABLE),Y
           RTS

TABLE
           .TEXT "BRK"
           .WORD BRKN
           .BYTE $1B,$C6,$B1,$6C,$34
           .TEXT "ORA"
           .WORD IX
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "ASO"
           .WORD IX
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD Z
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "ASL"
           .WORD Z
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "ASO"
           .WORD Z
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "PHP"
           .WORD PHPN
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD B
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "ASL"
           .WORD N
           .BYTE $1B,$8C,$B1,$6C,$B1
           .TEXT "ANC"
           .WORD B
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "NOP"
           .WORD A
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD A
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "ASL"
           .WORD A
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "ASO"
           .WORD A
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "BPL"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "ORA"
           .WORD IY
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "ASO"
           .WORD IY
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD ZX
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "ASL"
           .WORD ZX
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "ASO"
           .WORD ZX
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "CLC"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD AY
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ASO"
           .WORD AY
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ORA"
           .WORD AX
           .BYTE $1B,$DF,$B1,$6C,$B0
           .TEXT "ASL"
           .WORD AX
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "ASO"
           .WORD AX
           .BYTE $36,$F6,$B1,$6C,$B0
           .TEXT "JSR"
           .WORD JSRW
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AND"
           .WORD IX
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "RLA"
           .WORD IX
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "BIT"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AND"
           .WORD Z
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "ROL"
           .WORD Z
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "RLA"
           .WORD Z
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "PLP"
           .WORD PLPN
           .BYTE $1B,$C6,$B1,$6C,$B3
           .TEXT "AND"
           .WORD B
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "ROL"
           .WORD N
           .BYTE $1B,$8C,$B1,$6C,$B1
           .TEXT "ANC"
           .WORD B
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "BIT"
           .WORD A
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AND"
           .WORD A
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "ROL"
           .WORD A
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "RLA"
           .WORD A
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "BMI"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "AND"
           .WORD IY
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "RLA"
           .WORD IY
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AND"
           .WORD ZX
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "ROL"
           .WORD ZX
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "RLA"
           .WORD ZX
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "SEC"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$31
           .TEXT "AND"
           .WORD AY
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "RLA"
           .WORD AY
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AND"
           .WORD AX
           .BYTE $1B,$02,$B1,$6C,$30
           .TEXT "ROL"
           .WORD AX
           .BYTE $36,$C6,$B1,$6C,$30
           .TEXT "RLA"
           .WORD AX
           .BYTE $36,$06,$B1,$6C,$30
           .TEXT "RTI"
           .WORD RTIN
           .BYTE $1B,$C6,$B1,$6C,$B3
           .TEXT "EOR"
           .WORD IX
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "LSE"
           .WORD IX
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD Z
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "LSR"
           .WORD Z
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "LSE"
           .WORD Z
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "PHA"
           .WORD PHAN
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD B
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "LSR"
           .WORD N
           .BYTE $1B,$63,$B1,$6C,$30
           .TEXT "ALR"
           .WORD B
           .BYTE $1B,$01,$B1,$6C,$30
           .TEXT "JMP"
           .WORD JMPW
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD A
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "LSR"
           .WORD A
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "LSE"
           .WORD A
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "BVC"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "EOR"
           .WORD IY
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "LSE"
           .WORD IY
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD ZX
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "LSR"
           .WORD ZX
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "LSE"
           .WORD ZX
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "CLI"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD AY
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "LSE"
           .WORD AY
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "EOR"
           .WORD AX
           .BYTE $1B,$DD,$B1,$6C,$B0
           .TEXT "LSR"
           .WORD AX
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "LSE"
           .WORD AX
           .BYTE $0D,$CB,$B1,$6C,$B1
           .TEXT "RTS"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ADC"
           .WORD IX
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "RRA"
           .WORD IX
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ADC"
           .WORD Z
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "ROR"
           .WORD Z
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "RRA"
           .WORD Z
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "PLA"
           .WORD PLAN
           .BYTE $1B,$F0,$B1,$6C,$B0
           .TEXT "ADC"
           .WORD B
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "ROR"
           .WORD N
           .BYTE $1B,$63,$B1,$6C,$30
           .TEXT "ARR"
           .WORD B
           .BYTE $1B,$01,$B1,$6C,$30
           .TEXT "JMP"
           .WORD JMPI
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ADC"
           .WORD A
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "ROR"
           .WORD A
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "RRA"
           .WORD A
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "BVS"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "ADC"
           .WORD IY
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "RRA"
           .WORD IY
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ADC"
           .WORD ZX
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "ROR"
           .WORD ZX
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "RRA"
           .WORD ZX
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "SEI"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$34
           .TEXT "ADC"
           .WORD AY
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "RRA"
           .WORD AY
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "ADC"
           .WORD AX
           .BYTE $1B,$E1,$B1,$6C,$B0
           .TEXT "ROR"
           .WORD AX
           .BYTE $0D,$C6,$B1,$6C,$31
           .TEXT "RRA"
           .WORD AX
           .BYTE $0D,$D4,$B1,$6C,$B0
           .TEXT "NOP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "STA"
           .WORD IX
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "NOP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "AXS"
           .WORD IX
           .BYTE $80,$C6,$B1,$6C,$30
           .TEXT "STY"
           .WORD Z
           .BYTE $6C,$C6,$B1,$6C,$30
           .TEXT "STA"
           .WORD Z
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "STX"
           .WORD Z
           .BYTE $B1,$C6,$B1,$6C,$30
           .TEXT "AXS"
           .WORD Z
           .BYTE $80,$C6,$B1,$6C,$30
           .TEXT "DEY"
           .WORD N
           .BYTE $1B,$C6,$B1,$6B,$30
           .TEXT "NOP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "TXA"
           .WORD N
           .BYTE $1B,$B1,$B1,$6C,$B0
           .TEXT "ANE"
           .WORD B
           .BYTE $1B,$00,$B1,$6C,$32
           .TEXT "STY"
           .WORD A
           .BYTE $6C,$C6,$B1,$6C,$30
           .TEXT "STA"
           .WORD A
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "STX"
           .WORD A
           .BYTE $B1,$C6,$B1,$6C,$30
           .TEXT "AXS"
           .WORD A
           .BYTE $80,$C6,$B1,$6C,$30
           .TEXT "BCC"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "STA"
           .WORD IY
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "SHA"
           .WORD SHAIY
           .BYTE $00,$C6,$B1,$6C,$30
           .TEXT "STY"
           .WORD ZX
           .BYTE $6C,$C6,$B1,$6C,$30
           .TEXT "STA"
           .WORD ZX
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "STX"
           .WORD ZY
           .BYTE $B1,$C6,$B1,$6C,$30
           .TEXT "AXS"
           .WORD ZY
           .BYTE $80,$C6,$B1,$6C,$30
           .TEXT "TYA"
           .WORD N
           .BYTE $1B,$6C,$B1,$6C,$30
           .TEXT "STA"
           .WORD AY
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "TXS"
           .WORD TXSN
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "SHS"
           .WORD SHSAY
           .BYTE $00,$C6,$B1,$6C,$30
           .TEXT "SHY"
           .WORD SHYAX
           .BYTE $00,$C6,$B1,$6C,$30
           .TEXT "STA"
           .WORD AX
           .BYTE $C6,$C6,$B1,$6C,$30
           .TEXT "SHX"
           .WORD SHXAY
           .BYTE $00,$C6,$B1,$6C,$30
           .TEXT "SHA"
           .WORD SHAAY
           .BYTE $00,$C6,$B1,$6C,$30
           .TEXT "LDY"
           .WORD B
           .BYTE $1B,$C6,$B1,$1B,$30
           .TEXT "LDA"
           .WORD IX
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "LDX"
           .WORD B
           .BYTE $1B,$C6,$1B,$6C,$30
           .TEXT "LAX"
           .WORD IX
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "LDY"
           .WORD Z
           .BYTE $1B,$C6,$B1,$1B,$30
           .TEXT "LDA"
           .WORD Z
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "LDX"
           .WORD Z
           .BYTE $1B,$C6,$1B,$6C,$30
           .TEXT "LAX"
           .WORD Z
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "TAY"
           .WORD N
           .BYTE $1B,$C6,$B1,$C6,$B0
           .TEXT "LDA"
           .WORD B
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "TAX"
           .WORD N
           .BYTE $1B,$C6,$C6,$6C,$B0
           .TEXT "LXA"
           .WORD B
           .BYTE $1B,$0A,$0A,$6C,$30
           .TEXT "LDY"
           .WORD A
           .BYTE $1B,$C6,$B1,$1B,$30
           .TEXT "LDA"
           .WORD A
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "LDX"
           .WORD A
           .BYTE $1B,$C6,$1B,$6C,$30
           .TEXT "LAX"
           .WORD A
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "BCS"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "LDA"
           .WORD IY
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "LAX"
           .WORD IY
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "LDY"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$1B,$30
           .TEXT "LDA"
           .WORD ZX
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "LDX"
           .WORD ZY
           .BYTE $1B,$C6,$1B,$6C,$30
           .TEXT "LAX"
           .WORD ZY
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "CLV"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "LDA"
           .WORD AY
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "TSX"
           .WORD TSXN
           .BYTE $1B,$C6,$00,$6C,$00
           .TEXT "LAS"
           .WORD LASAY
           .BYTE $1B,$00,$00,$6C,$00
           .TEXT "LDY"
           .WORD AX
           .BYTE $1B,$C6,$B1,$1B,$30
           .TEXT "LDA"
           .WORD AX
           .BYTE $1B,$1B,$B1,$6C,$30
           .TEXT "LDX"
           .WORD AY
           .BYTE $1B,$C6,$1B,$6C,$30
           .TEXT "LAX"
           .WORD AY
           .BYTE $1B,$1B,$1B,$6C,$30
           .TEXT "CPY"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$31
           .TEXT "CMP"
           .WORD IX
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD IX
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "CPY"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$31
           .TEXT "CMP"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "DEC"
           .WORD Z
           .BYTE $1A,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD Z
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "INY"
           .WORD N
           .BYTE $1B,$C6,$B1,$6D,$30
           .TEXT "CMP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "DEX"
           .WORD N
           .BYTE $1B,$C6,$B0,$6C,$B0
           .TEXT "SBX"
           .WORD B
           .BYTE $1B,$C6,$65,$6C,$31
           .TEXT "CPY"
           .WORD A
           .BYTE $1B,$C6,$B1,$6C,$31
           .TEXT "CMP"
           .WORD A
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "DEC"
           .WORD A
           .BYTE $1A,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD A
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "BNE"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "CMP"
           .WORD IY
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "DCM"
           .WORD IY
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "CMP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "DEC"
           .WORD ZX
           .BYTE $1A,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD ZX
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "CLD"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "CMP"
           .WORD AY
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD AY
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "CMP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "DEC"
           .WORD AX
           .BYTE $1A,$C6,$B1,$6C,$30
           .TEXT "DCM"
           .WORD AX
           .BYTE $1A,$C6,$B1,$6C,$B1
           .TEXT "CPX"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "SBC"
           .WORD IX
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD B
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD IX
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "CPX"
           .WORD Z
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "SBC"
           .WORD Z
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "INC"
           .WORD Z
           .BYTE $1C,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD Z
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "INX"
           .WORD N
           .BYTE $1B,$C6,$B2,$6C,$B0
           .TEXT "SBC"
           .WORD B
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "SBC"
           .WORD B
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "CPX"
           .WORD A
           .BYTE $1B,$C6,$B1,$6C,$B1
           .TEXT "SBC"
           .WORD A
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "INC"
           .WORD A
           .BYTE $1C,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD A
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "BEQ"
           .WORD R
           .BYTE $1B,$C6,$B1,$6C,$F3
           .TEXT "SBC"
           .WORD IY
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "HLT"
           .WORD HLTN
           .BYTE $00,$00,$00,$00,$00
           .TEXT "INS"
           .WORD IY
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD ZX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "SBC"
           .WORD ZX
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "INC"
           .WORD ZX
           .BYTE $1C,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD ZX
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "SED"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$38
           .TEXT "SBC"
           .WORD AY
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD N
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD AY
           .BYTE $1C,$A9,$B1,$6C,$B1
           .TEXT "NOP"
           .WORD AX
           .BYTE $1B,$C6,$B1,$6C,$30
           .TEXT "SBC"
           .WORD AX
           .BYTE $1B,$AA,$B1,$6C,$B1
           .TEXT "INC"
           .WORD AX
           .BYTE $1C,$C6,$B1,$6C,$30
           .TEXT "INS"
           .WORD AX
           .BYTE $1C,$A9,$B1,$6C,$B1
           .BYTE 0

